create or replace
TRIGGER SJS.WC_NYDEX_INSERT
BEFORE INSERT ON SJS.WARRANTCHARGES
FOR EACH ROW
BEGIN
  insert into NYDEX.NYDEX_MOD_LOG values (:new.i_id,'GREEN',null,1,'M',:new.i_agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace
TRIGGER SJS.WC_NYDEX_UPDATE
BEFORE UPDATE ON SJS.WARRANTCHARGES
FOR EACH ROW
BEGIN
  insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace
TRIGGER SJS.ACW_NYDEX_UPDATE
BEFORE UPDATE ON SJS.ARRESTCHARGESWEAPONS
FOR EACH ROW
BEGIN
    insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace
TRIGGER SJS.ACW_NYDEX_INSERT
BEFORE INSERT ON SJS.ARRESTCHARGESWEAPONS
FOR EACH ROW
declare
iid number(18);
agcyori varchar2(9);
BEGIN
 for i  in (SELECT ac.i_id,ac.i_agcy_ori FROM sjs.arrestcharges ac WHERE ac.ac_id = :new.ac_id)
 loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
 end loop;
END;
/

create or replace
TRIGGER SJS.IOFW_NYDEX_UPDATE
BEFORE UPDATE ON SJS.INCIDENTOFFENSEWEAPONS
FOR EACH ROW
BEGIN
    insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace
TRIGGER SJS.IOFW_NYDEX_INSERT
BEFORE INSERT ON SJS.INCIDENTOFFENSEWEAPONS
FOR EACH ROW
BEGIN
 for i  in (SELECT ac.i_id,ac.agcy_ori FROM sjs.incidentcharges ac WHERE ac.ic_id = :new.ic_id)
 loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
 end loop;
END;
/

create or replace
TRIGGER sjs.IOFW_NYDEX_DELETE
 BEFORE DELETE ON sjs.INCIDENTOFFENSEWEAPONS
FOR EACH ROW
BEGIN
    insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace
TRIGGER SJS.VS_NYDEX_INSERT
BEFORE INSERT ON SJS.VICTIMSUSPECT
FOR EACH ROW
BEGIN
    for i in (select ip.i_id,ip.agcy_ori from sjs.incidentpeople ip WHERE ip.ip_id = :new.ip_victim_id)
    loop
      insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
    end loop;      
END;
/

create or replace
TRIGGER SJS.VS_NYDEX_UPDATE
BEFORE UPDATE OF
       RELATIONSHIPID
       ON SJS.VICTIMSUSPECT
       FOR EACH ROW
BEGIN
         insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.VS_NYDEX_DELETE_BDFER
BEFORE DELETE ON SJS.VICTIMSUSPECT
FOR EACH ROW
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
ori varchar2(9);
iid number(23);
BEGIN
    NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
    NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.i_agcy_ori;
END;
/

create or replace
TRIGGER SJS.PP_NYDEX_INSERT
before INSERT ON SJS.PERSONPHONE
FOR EACH ROW
declare
incnt number(3);
arcnt number(3);
wcnt number(3);
iid number(23);
ori varchar2(9);
BEGIN
        select count(*) into incnt from sjs.incidentpeople where pd_id=:new.pd_id;
        if incnt >0 then
          for i in (select i_id,agcy_ori from sjs.incidentpeople where pd_id=:new.pd_id)
          loop
            if i.i_id is not null and i.agcy_ori is not null  then
              insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
            end if;
          end loop;
        else
        select count(*) into arcnt from sjs.arrestpeople where pd_id=:new.pd_id;
            if arcnt > 0 then
              for i in (
                        select distinct ac.i_id,ac.agcy_ori
                        from sjs.arrestpeople ap,sjs.arrestcharges ac where ap.pd_id=:new.pd_id
                        and ap.a_id=ac.a_id
                        )
             loop
              if i.i_id is not null and i.agcy_ori is not null then
              insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
            end if;
             end loop;
            else
                select count(*) into wcnt from sjs.warrantpeople where pd_id=:new.pd_id;
                if wcnt > 0 then
                 for i in  (
                          select distinct ac.i_id,ac.agcy_ori
                          from sjs.warrantpeople ap,sjs.warrantcharges ac where ap.pd_id=:new.pd_id
                          and ap.w_id=ac.w_id
                          )
                  loop
                    if i.i_id is not null and i.agcy_ori is not null  then
                      insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
                    end if;
                  end loop;
                end if;
            end if;
        end if;
END;
/

create or replace TRIGGER SJS.PP_NYDEX_UPDATE
BEFORE UPDATE OF
       PP_PHONE_NUMBER,
       PHONETYPEID,
       PP_EXTENSION
       ON SJS.PERSONPHONE
       FOR EACH ROW
BEGIN
   if :new.i_id is not null and :new.i_agcy_ori is not null then
    insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
   end if;    
END;
/

create or replace TRIGGER SJS.PP_NYDEX_DELETE
BEFORE DELETE
       ON SJS.PERSONPHONE
       FOR EACH ROW
BEGIN
   if :old.i_id is not null and :old.i_agcy_ori is not null then
    insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
   end if;    
END;
/

create or replace
TRIGGER SJS.IP_NYDEX_INSERT
AFTER INSERT ON SJS.INCIDENTPEOPLE
for each row
BEGIN
  insert into NYDEX.NYDEX_MOD_LOG values (:new.i_id,'GREEN',null,1,'M',:new.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace
TRIGGER SJS.WP_NYDEX_INSERT
AFTER INSERT ON SJS.WARRANTPEOPLE
FOR EACH ROW
BEGIN
 for i in
  (
  select i_id,i_agcy_ori from sjs.warrantcharges where w_id =:new.w_id and agcy_ori=:new.agcy_ori
  )
  loop
  insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace
TRIGGER SJS.AP_NYDEX_INSERT
BEFORE INSERT ON SJS.ARRESTPEOPLE
FOR EACH ROW
BEGIN
  for i in (select i_id,i_agcy_ori from sjs.arrestcharges where a_id =:new.a_id and agcy_ori=:new.agcy_ori)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.PH_NYDEX_UPDATE
BEFORE UPDATE ON SJS.personphoto
FOR EACH ROW
BEGIN
if :old.i_id is not null and :old.i_agcy_ori is not null then
    insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
   end if; 
END;
/

create or replace TRIGGER SJS.PH_NYDEX_DELETE
BEFORE DELETE
ON SJS.personphoto
FOR EACH ROW
BEGIN
  if :old.i_id is not null and :old.i_agcy_ori is not null then
    insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
   end if; 
END;
/

create or replace
TRIGGER SJS.PH_NYDEX_INSERT
BEFORE INSERT ON SJS.PERSONPHOTO
FOR EACH ROW
declare
incnt number(3);
arcnt number(3);
wcnt number(3);
iid number(23);
ori varchar2(9);
BEGIN
        select count(*) into incnt from sjs.incidentpeople where pd_id=:new.pd_id;
        if incnt >0 then
          for i in (select i_id,agcy_ori from sjs.incidentpeople where pd_id=:new.pd_id)
          loop
            if i.i_id is not null and i.agcy_ori is not null  then
              insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
            end if;
          end loop;
        else
        select count(*) into arcnt from sjs.arrestpeople where pd_id=:new.pd_id;
            if arcnt > 0 then
              for i in (
                        select distinct ac.i_id,ac.agcy_ori
                        from sjs.arrestpeople ap,sjs.arrestcharges ac where ap.pd_id=:new.pd_id
                        and ap.a_id=ac.a_id
                        )
             loop
              if i.i_id is not null and i.agcy_ori is not null then
              insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
            end if;
             end loop;
            else
                select count(*) into wcnt from sjs.warrantpeople where pd_id=:new.pd_id;
                if wcnt > 0 then
                 for i in  (
                          select distinct ac.i_id,ac.agcy_ori
                          from sjs.warrantpeople ap,sjs.warrantcharges ac where ap.pd_id=:new.pd_id
                          and ap.w_id=ac.w_id
                          )
                  loop
                    if i.i_id is not null and i.agcy_ori is not null  then
                      insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
                    end if;
                  end loop;
                end if;
            end if;
        end if;
END;
/
