create or replace
trigger sjs.acw_new
before insert on sjs.ArrestChargesWeapons
for each row
declare
  l_priv pls_integer := nvl(sys_context('sjs','secmx_arrest_add'), 0);
begin
  -- $Id: acw_new.sql,v 1.2 2006/04/22 14:24:36 adrury Exp $
  if (1 <> l_priv ) then
    raise_application_error(-20001,'secmx_arrest_add must be included in user''s security matrix');
  end if;
  select user,sysdate into :new.u_name,:new.acw_ent_date from dual;
  if (:new.acw_id is null) then
    select acw_sequence.nextval into :new.acw_id from dual;
  end if;
  select ac.i_id,ac.agcy_ori into :new.i_id,:new.i_agcy_ori from sjs.arrestcharges ac WHERE ac.ac_id = :new.ac_id;
end;
/

create or replace
trigger sjs.iow_new
before insert on sjs.IncidentOffenseWeapons
for each row
declare
 l_priv pls_integer := nvl(sys_context('sjs','secmx_incident_add'), 0);
begin
 -- $Id: iow_new.sql,v 1.3 2006/04/22 14:24:36 adrury Exp $
 if (1 <> l_priv ) then
   raise_application_error(-20001,'secmx_incident_add must be included in user''s security matrix');
 end if;
 select user,sysdate into :new.u_name,:new.iow_ent_date from dual;
 if (:new.iow_id is null) then
   select iow_sequence.nextval into :new.iow_id from dual;
 end if;
 select ac.i_id,ac.agcy_ori into :new.i_id,:new.i_agcy_ori from sjs.incidentcharges ac WHERE ac.ic_id = :new.ic_id;
end;
/

create or replace
trigger sjs.ph_new
before insert on sjs.PersonPhoto
for each row
declare
incnt number(3);
arcnt number(3);
wcnt number(3);
iid number(23);
ori varchar2(9);
begin
  -- $Id: ph_new.sql,v 1.2 2006/07/13 14:31:32 adrury Exp $
  select user,sysdate into :new.u_name,:new.ph_ent_date from dual;
  if (:new.ph_id is null) then
    select personphoto_sequence.nextval into :new.ph_id from dual;
  end if;
  if (:new.ph_photo_date is null) then
    select sysdate into :new.ph_photo_date from dual;
  end if;
  select count(*) into incnt from sjs.incidentpeople where pd_id=:new.pd_id;
        if incnt >0 then
          for i in (select i_id,agcy_ori from sjs.incidentpeople where pd_id=:new.pd_id)
          loop
            if i.i_id is not null and i.agcy_ori is not null  then
              :new.i_id:=i.i_id;
              :new.i_agcy_ori:=i.agcy_ori;
            end if;
          end loop;
        else
        select count(*) into arcnt from sjs.arrestpeople where pd_id=:new.pd_id;
            if arcnt > 0 then
              for i in (
                        select distinct ac.i_id,ac.agcy_ori
                        from sjs.arrestpeople ap,sjs.arrestcharges ac where ap.pd_id=:new.pd_id
                        and ap.a_id=ac.a_id
                        )
             loop
              if i.i_id is not null and i.agcy_ori is not null then
              :new.i_id:=i.i_id;
              :new.i_agcy_ori:=i.agcy_ori;
            end if;
             end loop;
            else
                select count(*) into wcnt from sjs.warrantpeople where pd_id=:new.pd_id;
                if wcnt > 0 then
                 for i in  (
                          select distinct ac.i_id,ac.agcy_ori
                          from sjs.warrantpeople ap,sjs.warrantcharges ac where ap.pd_id=:new.pd_id
                          and ap.w_id=ac.w_id
                          )
                  loop
                    if i.i_id is not null and i.agcy_ori is not null  then
                      :new.i_id:=i.i_id;
                      :new.i_agcy_ori:=i.agcy_ori;
                    end if;
                  end loop;
                end if;
            end if;
        end if;
end;
/

create or replace
trigger sjs.pp_new
before insert on sjs.PersonPhone
for each row
declare
incnt number(3);
arcnt number(3);
wcnt number(3);
iid number(23);
ori varchar2(9);
begin
  -- $Id: pp_new.sql,v 1.2 2006/04/22 14:24:36 adrury Exp $
  select user,sysdate into :new.u_name,:new.pp_ent_date from dual;
  if (:new.pp_id is null) then
    select pp_sequence.nextval into :new.pp_id from dual;
  end if;
  
  
   select count(*) into incnt from sjs.incidentpeople where pd_id=:new.pd_id;
        if incnt >0 then
          for i in (select i_id,agcy_ori from sjs.incidentpeople where pd_id=:new.pd_id)
          loop
            if i.i_id is not null and i.agcy_ori is not null  then
              :new.i_id:=i.i_id;
              :new.i_agcy_ori:=i.agcy_ori;
            end if;
          end loop;
        else
        select count(*) into arcnt from sjs.arrestpeople where pd_id=:new.pd_id;
            if arcnt > 0 then
              for i in (
                        select distinct ac.i_id,ac.agcy_ori
                        from sjs.arrestpeople ap,sjs.arrestcharges ac where ap.pd_id=:new.pd_id
                        and ap.a_id=ac.a_id
                        )
             loop
              if i.i_id is not null and i.agcy_ori is not null then
              :new.i_id:=i.i_id;
              :new.i_agcy_ori:=i.agcy_ori;
            end if;
             end loop;
            else
                select count(*) into wcnt from sjs.warrantpeople where pd_id=:new.pd_id;
                if wcnt > 0 then
                 for i in  (
                          select distinct ac.i_id,ac.agcy_ori
                          from sjs.warrantpeople ap,sjs.warrantcharges ac where ap.pd_id=:new.pd_id
                          and ap.w_id=ac.w_id
                          )
                  loop
                    if i.i_id is not null and i.agcy_ori is not null  then
                      :new.i_id:=i.i_id;
                      :new.i_agcy_ori:=i.agcy_ori;
                    end if;
                  end loop;
                end if;
            end if;
        end if;
end;
/

create or replace
TRIGGER SJS.VS_NEW
BEFORE INSERT 
ON SJS.VICTIMSUSPECT
REFERENCING OLD AS OLD NEW AS NEW
FOR EACH ROW 
Begin
  SELECT VS_Sequence.nextval, sysdate
    INTO :new.VS_id, :new.VS_ent_date
    FROM Dual;
    select ip.i_id,ip.agcy_ori into :new.i_id,:new.i_agcy_ori from sjs.incidentpeople ip WHERE ip.ip_id = :new.ip_victim_id;
End;
/

create or replace
trigger sjs.ip_new
before insert on sjs.IncidentPeople
for each row
declare
 l_priv pls_integer := nvl(sys_context('sjs','secmx_incident_add'), 0);
begin
 -- $Id: ip_new.sql,v 1.7 2006/04/22 14:24:36 adrury Exp $
 if (1 <> l_priv ) then
   raise_application_error(-20001,'secmx_incident_add must be included in user''s security matrix');
 end if;
 if (1 = sjs.incidents_utl.is_locked(:new.i_id, :new.agcy_ori)) then
   raise_application_error(-20001,'Can''t modify locked incident '||:new.i_id||', '||:new.agcy_ori);
 end if;
 select user,sysdate into :new.u_name,:new.ip_ent_date from dual;
 if (:new.ip_id is null) then
   select ip_sequence.nextval into :new.ip_id from dual;
 end if;
  update sjs.personphone set i_id=:new.i_id,i_agcy_ori=:new.agcy_ori
  where pd_id=:new.pd_id;
  update sjs.personphoto set i_id=:new.i_id,i_agcy_ori=:new.agcy_ori
  where pd_id=:new.pd_id;
end;
/

create or replace
trigger sjs.wp_new
before insert on sjs.WarrantPeople
for each row
declare
  l_priv pls_integer := nvl(sys_context('sjs','secmx_warrant_add'), 0);
begin
  -- $Id: wp_new.sql,v 1.3 2006/06/10 15:38:42 adrury Exp $
  if (1 <> l_priv ) then
    raise_application_error(-20001,'secmx_warrant_add must be included in user''s security matrix');
  end if;
  select user,sysdate into :new.u_name,:new.wp_ent_date from dual;
  if (:new.wp_id is null) then
    select wp_sequence.nextval into :new.wp_id from dual;
  end if;
  for i in
    (
      select i_id,i_agcy_ori from sjs.warrantcharges where w_id =:new.w_id and agcy_ori=:new.agcy_ori
    )
  loop
    update sjs.personphone set i_id=i.i_id,i_agcy_ori=i.i_agcy_ori
    where pd_id=:NEW.PD_ID;
    update sjs.personphoto set i_id=i.i_id,i_agcy_ori=i.i_agcy_ori
    where pd_id=:NEW.PD_ID;
  end loop;
end;
/

create or replace
trigger sjs.ap_new
before insert on sjs.ArrestPeople
for each row
declare
  l_priv pls_integer := nvl(sys_context('sjs','secmx_arrest_add'), 0);
begin
  -- $Id: ap_new.sql,v 1.2 2006/04/22 14:24:36 adrury Exp $
  if (1 <> l_priv ) then
    raise_application_error(-20001,'secmx_arrest_add must be included in user''s security matrix');
  end if;
  select user,sysdate into :new.u_name,:new.ap_ent_date from dual;
  if (:new.ap_id is null) then
    select ap_sequence.nextval into :new.ap_id from dual;
  end if;
  
for i in (select i_id,i_agcy_ori from sjs.arrestcharges where a_id =:new.a_id and agcy_ori=:new.agcy_ori)
    loop
    
      update sjs.personphone set i_id=i.i_id,i_agcy_ori=i.i_agcy_ori
      where pd_id=:NEW.PD_ID;
      update sjs.personphoto set i_id=i.i_id,i_agcy_ori=i.i_agcy_ori
      where pd_id=:NEW.PD_ID;
    end loop;
end;
/